options(contrasts = c("contr.treatment", "contr.poly"))
library(repeated)
library(gnlm)

y <- as.vector(t(read.table("transfor.dat",skip=7)))
wt <- as.numeric(y>-1)
y <- ifelse(y>0,y,2)
tension <- gl(2,1,32)
location <- gl(2,2,32)
spring <- gl(4,1,32)
sheet <- gl(4,4,32)
coat <- gl(2,16,32)

summary(z0 <- glm(y~coat*spring,weights=wt))
summary(z <- glm(y~coat/spring+coat/sheet,weights=wt))
summary(z1 <- glm(y~coat+spring+coat/sheet,weights=wt))
summary(z2 <- glm(y~coat+coat/sheet,weights=wt))
summary(z2a <- glm(y~coat+tension+location+coat/sheet,weights=wt))
summary(z2b <- glm(y~coat+tension+coat/sheet,weights=wt))
summary(z2c <- glm(y~coat+location+coat/sheet,weights=wt))
summary(z3 <- glm(y~coat/sheet,weights=wt))
summary(z4 <- glm(y~coat,weights=wt))
summary(z5 <- glm(y~1,weights=wt))
ss <- double(8)
ss[1] <- z5$dev-z4$dev
ss[2] <- z4$dev-z3$dev
ss[3] <- z2$dev-z1$dev
ss[4] <- z2b$dev-z2a$dev
ss[5] <- z2c$dev-z2a$dev
ss[6] <- z2a$dev-z1$dev
ss[7] <- z1$dev-z$dev
ss[8] <- z$dev
d.f <- c(1,6,3,1,1,1,3,16)
ff <- ss*d.f[8]/d.f/ss[8]
ff[1:2] <- ss[1:2]*d.f[2]/d.f[1:2]/ss[2]
anova.table <- cbind(ss,d.f,ss/d.f,ff)
colnames(anova.table) <- c("SS","df","MSS","F")
rownames(anova.table) <- c("Coating","Coating/Sheets","Spring","Location",
	"Tension","Interaction","Coating/Spring","Residual")
anova.table

print(a <- ((z4$dev-z3$dev)/d.f[2]-z$dev/d.f[8])/4)
a/(a+z$dev/d.f[8])
print(s0 <- matrix(rep(a,16),nrow=4)+diag(z$dev/d.f[8],4))

res <- matrix((y-z0$fit)*wt,ncol=4,byrow=T)
print(s1 <- diag(sqrt(c(1/7,1/8,1/7,1/8)))%*%t(res)%*%res%*%diag(sqrt(c(1/7,1/8,1/7,1/8))))

30*(1+log(2*pi))/2+(6*log(det(s0))+log(det(s0[-1,-1]))+
	log(det(s0[-3,-3])))/2+8+2
30*(1+log(2*pi))/2+(6*log(det(s1))+log(det(s1[-1,-1]))+
	log(det(s1[-3,-3])))/2+8+10
30*(1+log(2*pi))/2+30*log(z0$dev/30)/2+8+1

# Chapter 6
data <- data.frame(y,coat,spring,tension,location,as.numeric(wt))
sheet <- gl(8,4,32)

print(summary(uug <- glm(y~coat*spring,data=data,weights=wt,
	family=Gamma(link="log"))))
uug$aic/2
print(summary(ug <- glmm(y~coat*spring,data=data,weights=wt,nest=sheet,
	family=Gamma(link="log"),points=4)))
ug$aic/2

ln <- log(y)
data <- data.frame(ln,coat,spring,tension,location,as.numeric(wt))
print(summary(uuln <-  glm(ln~coat*spring,weights=wt)))
uuln$aic/2+sum(log(y))
print(summary(uln <-  glmm(ln~coat*spring,data=data,weights=wt,nest=sheet)))
uln$aic/2+sum(log(y))

mu <- function(p,linear) exp(linear)
print(uuw <- gnlr(y,"Weibull",mu=mu,linear=~coat*spring,wt=wt,
	pmu=c(4.2,-0.06,-0.1,0.43,0.39,0.39,-0.68,-0.35),psh=1))
uuw$aic/2
print(uw <- gnlmm(y,"Weibull",mu=mu,linear=~coat*spring,nest=sheet,wt=wt,
	pmu=uuw$coef[1:8],psh=1.71,psd=0.001))
uw$aic/2

print(uul <- gnlr(y,"logistic",mu=~coat*spring,wt=wt,
	pmu=c(66.5,-3.58,-6.75,35.9,32.25,27.08,-29.6,-29.9),psh=1))
uul$aic/2
print(ul <- gnlmm(y,"logistic",mu=~coat*spring,nest=sheet,wt=wt,points=3,
	pmu=c(66.5,-3.58,-6.75,35.9,32.25,27.08,-29.6,-29.9),psh=1,psd=1))
ul$aic/2
