options(contrasts = c("contr.sum", "contr.poly"))
library(growth)
library(repeated)

y <- as.matrix(read.table("tubercul.dat",skip=8))
treat <- as.factor(y[,2])
y <- y[,1]
ly <- log(y)
site <- gl(4,4,16)
group <- gl(4,1,16)

z <- lm(ly~group+site+treat)
anova(z)
res <- glm(ly~treat+site+group)$deviance
ss.group <- glm(ly~treat+site)$deviance-res
ss.site <- glm(ly~treat+group)$deviance-res
ss.treat <- glm(ly~site+group)$deviance-res
ss <- c(ss.group,ss.site,ss.treat,res)
ss.df <- c(3,3,3,6)
anova.table <- cbind(ss,ss.df,ss/ss.df,ss*ss.df[4]/ss.df/ss[4])
colnames(anova.table) <- c("SS","df","MSS","F")
rownames(anova.table) <- c("Group","Site","Treatment","Residual")
anova.table

summary(rmaov(matrix(ly,nrow=4),site,ccov=treat))

30*res/6
(ss.group/3-res/6)*30/4
(ss.group/3-res/6)*30/4+res*30/6
summary(z2 <- glm(ly~treat+site))
-(z2$coef[2]+z2$coef[3]+z2$coef[4])
-(z2$coef[5]+z2$coef[6]+z2$coef[7])

print(s0 <- matrix(rep((ss.group/4-res/8)*30/4,16),nrow=4)+diag(res*30/8,4))
16*(1+log(2*pi))/2+4*log(det(s0))/2+sum(ly)+7+2
16*(1+log(2*pi))/2+16*log(30*z2$dev/16)/2+sum(ly)+7+1

# Chapter 6
summary(un <- glmm(y~treat+site,nest=group,points=5))
un$aic/2+8*log(30)
summary(uln <- glmm(ly~treat+site,delta=1/y,nest=group,points=5))
uln$aic/2+8*log(30)
summary(ug <- glmm(y~treat+site,nest=group,family=Gamma(link="log"),points=4))
ug$aic/2+8*log(30)
mu <- function(p,linear) exp(linear)
print(zw <- gnlmm(y,"Weibull",mu=mu,linear=~treat+site,nest=group,points=3,
	pmu=c(5.85,0.1,-0.1,0.1,-0.04,0.05,0.09),psh=2.5,psd=0.13,
	stepmax=0.005))
zw$aic+8*log(30)
