library(growth)

resp <- restovec(read.list("ultrafil.dat",order=c(2,1)))
centre <- cbind(c(rep(0,17),rep(1,13),rep(0,11)),c(rep(0,17),rep(0,13),rep(1,11)))
colnames(centre) <- c("Centre 2","Centre 3")

if(interactive()){
postscript("uf.eps",height=7,width=5)
par(mfrow=c(3,1),font.main=1,mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(resp,nind=1:17,ylim=c(0,2000),xlim=c(0,500),ylab="Ultrafiltration rate",
	xlab="",main="Centre 1",lty=1)
plot(resp,nind=18:30,ylim=c(0,2000),xlim=c(0,500),ylab="Ultrafiltration rate",
	xlab="",main="Centre 2",lty=1)
plot(resp,nind=31:41,ylim=c(0,2000),xlim=c(0,500),ylab="Ultrafiltration rate",
	xlab="Transmembrane pressure",main="Centre 3",lty=1)
dev.off()
}

carma(resp)
carma(resp,pre=1,pos=c(1,1))
carma(resp,pre=c(3,1),pos=rbind(c(1,1),c(2,2)))
carma(resp,pre=c(8.1,0.06,-0.15),pos=rbind(c(1,1),c(2,2),c(1,2)))
carma(resp,torder=1)
carma(resp,torder=1,pre=1.4,pos=c(1,1))
carma(resp,torder=1,pre=c(3,1),pos=rbind(c(1,1),c(2,2)))
carma(resp,torder=1,pre=c(1.5,0.06,-0.15),pos=rbind(c(1,1),c(2,2),c(1,2)))
carma(resp,torder=3)
carma(resp,torder=3,pre=1.4,pos=c(1,1))
carma(resp,torder=3,pre=c(3,1),pos=rbind(c(1,1),c(2,2)))
carma(resp,torder=3,pre=c(1.54,0.06,-0.15),pos=rbind(c(1,1),c(2,2),c(1,2)))
carma(resp,ccov=centre,torder=1)
carma(resp,ccov=centre,torder=1,pre=1.4,pos=c(1,1))
carma(resp,ccov=centre,torder=1,pre=c(3,1),pos=rbind(c(1,1),c(2,2)))
carma(resp,ccov=centre,torder=1,pre=c(1.4,0.06,-0.15),
	pos=rbind(c(1,1),c(2,2),c(1,2)))
carma(resp,ccov=centre,torder=1,interact=c(1,1))
carma(resp,ccov=centre,torder=1,interact=c(1,1),pre=1.2,pos=c(1,1))
carma(resp,ccov=centre,torder=1,interact=c(1,1),pre=c(3,1),
	pos=rbind(c(1,1),c(2,2)))
carma(resp,ccov=centre,torder=1,interact=c(1,1),pre=c(1,-0.1,1),
	pos=rbind(c(1,1),c(2,2),c(1,2)))

delta <- matrix(c(1252.5025,0,0,0.02928),ncol=2)
v <- rbind(rep(1,4),c(160,260,350,450)-305.6677)
print(m1 <- 733.9493*diag(4)+t(v)%*%delta%*%v)
sd1 <- sqrt(diag(m1))
m1/(sd1%o%sd1)

delta <- matrix(c(1290.5025,-0.3124,-0.3124,0.03025),ncol=2)
v <- rbind(rep(1,4),c(160,260,350,450)-305.6677)
print(m2 <- 733.2596*diag(4)+t(v)%*%delta%*%v)
sd2 <- sqrt(diag(m2))
m2/(sd2%o%sd2)

delta <- matrix(c(2186.62,-5.2655,-5.2655,0.0311),ncol=2)
v <- rbind(rep(1,4),c(160,260,350,450))
print(m3 <- 694.196*diag(4)+t(v)%*%delta%*%v)
sd3 <- sqrt(diag(m3))
m3/(sd3%o%sd3)
