library(growth)
options(contrasts = c("contr.sum", "contr.poly"))

resp <- as.matrix(read.table("vision.dat",skip=4))

if(interactive()){
postscript("vision.eps",height=5)
par(mfrow=c(1,2),font.main=1,mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(restovec(y[,1:4],times=c(1,3,6,10)),xlab="Power",ylab="Time lag (ms)",
	ylim=c(90,125),main="Left eye",xlim=c(0,10),lty=1,xaxt="n",yaxt="n")
axis(1,at=c(1,3,6,10))
axis(2,at=c(90,100,110,120))
plot(restovec(y[,5:8],times=c(1,3,6,10)),xlab="Power",ylab="",
	ylim=c(90,125),main="Right eye",xlim=c(0,10),lty=1,xaxt="n",yaxt="n")
axis(1,at=c(1,3,6,10))
axis(2,at=c(90,100,110,120))
dev.off()
}

y <- as.vector(t(resp))
power <- gl(4,1,56)
eye <- gl(2,4,56)
subject <- gl(7,8,56)

summary(z1 <- glm(y~eye/power+subject/power+subject/eye))
summary(z2 <- glm(y~subject/power+subject/eye))
summary(z3 <- glm(y~eye/power+subject/eye))
summary(z4 <- glm(y~eye+subject+power+subject/eye))
summary(z4a <- glm(y~eye+subject+subject/eye))
summary(z5 <- glm(y~subject/eye))
summary(z6 <- glm(y~subject+eye))
summary(z7 <- glm(y~subject))
summary(z8 <- glm(y~1))
ss <- double(7)
ss[1] <- z8$dev-z7$dev
ss[2] <- z7$dev-z6$dev
ss[3] <- z6$dev-z5$dev
ss[4] <- z4a$dev-z4$dev
ss[5] <- z3$dev-z1$dev
ss[6] <- z2$dev-z1$dev
ss[7] <- z1$dev
d.f <- c(6,1,6,3,18,3,18)
ff <- rep(1,7)
ff[6] <- ss[6]*d.f[7]/d.f[6]/ss[7]
ff[4] <- ss[4]*d.f[5]/d.f[4]/ss[5]
ff[2] <- ss[2]*d.f[3]/d.f[2]/ss[3]
anova.table <- cbind(ss,d.f,ss/d.f,ff)
colnames(anova.table) <- c("SS","df","MSS","F")
rownames(anova.table) <- c("Subject","Eye","Subject/Eye","Power",
	"Subject/Power","Eye/Power","Residual")
anova.table

summary(rmaov(resp,data.frame(eye,power)))

print(a <- (ss[5]/d.f[5]-z1$dev/d.f[7])/4)
print(b <- (ss[3]/d.f[3]-z1$dev/d.f[7])/8)
b/(a+b+z1$dev/d.f[7])
(a+b)/(a+b+z1$dev/d.f[7])
